"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var install_exports = {};
__export(install_exports, {
  execaWithStreamLog: () => execaWithStreamLog,
  npmInstall: () => npmInstall,
  pnpmInstall: () => pnpmInstall,
  runInstallWithNvm: () => runInstallWithNvm,
  yarnInstall: () => yarnInstall
});
module.exports = __toCommonJS(install_exports);
var import_execa = require("@modern-js/codesmith-utils/execa");
var import_npm = require("@modern-js/codesmith-utils/npm");
function execaWithStreamLog(command, args, options) {
  const promise = (0, import_execa.execa)(command, args, {
    ...options,
    stdin: "inherit",
    stdout: "inherit",
    stderr: "inherit"
  });
  return promise;
}
async function runInstallWithNvm(command, options) {
  return await (0, import_execa.execa)(`~/.nvm/nvm-exec ${command}`, {
    ...options,
    shell: true,
    stdin: "inherit",
    stdout: "inherit",
    stderr: "inherit"
  });
}
async function npmInstall({ cwd, registryUrl, ignoreScripts, useNvm }) {
  const canUse = await (0, import_npm.canUseNpm)();
  if (canUse) {
    const params = [
      "install"
    ];
    if (registryUrl) {
      params.push(`--registry=${registryUrl}`);
    }
    if (ignoreScripts) {
      params.push("--ignore-scripts");
    }
    if (useNvm) {
      return runInstallWithNvm(`npm ${params.join(" ")}`, {
        cwd,
        env: process.env
      });
    }
    return execaWithStreamLog("npm", params, {
      cwd,
      env: process.env
    });
  }
  throw new Error("please install npm first");
}
async function yarnInstall({ cwd, registryUrl, ignoreScripts, useNvm }) {
  const canUse = await (0, import_npm.canUseYarn)();
  if (canUse) {
    const params = [
      "install"
    ];
    if (registryUrl) {
      params.push(`--registry=${registryUrl}`);
    }
    if (ignoreScripts) {
      params.push("--ignore-scripts");
    }
    if (useNvm) {
      return runInstallWithNvm(`yarn ${params.join(" ")}`, {
        cwd,
        env: process.env
      });
    }
    return execaWithStreamLog("yarn", params, {
      cwd,
      env: process.env
    });
  }
  throw new Error("please install yarn first");
}
async function pnpmInstall({ cwd, registryUrl, ignoreScripts, useNvm }) {
  const canUse = await (0, import_npm.canUsePnpm)();
  if (canUse) {
    const params = [
      "install"
    ];
    if (registryUrl) {
      params.push(`--registry=${registryUrl}`);
    }
    if (ignoreScripts) {
      params.push("--ignore-scripts");
    }
    if (useNvm) {
      return runInstallWithNvm(`yarn ${params.join(" ")}`, {
        cwd,
        env: process.env
      });
    }
    return execaWithStreamLog("pnpm", params, {
      cwd,
      env: process.env
    });
  }
  throw new Error("please install pnpm first");
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  execaWithStreamLog,
  npmInstall,
  pnpmInstall,
  runInstallWithNvm,
  yarnInstall
});
